<?php
/**
 * ProjectTicketPrefs
 *
 * PHP version 5
 *
 * @category Class
 * @package  OSDN
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * OSDN REST API v0 beta
 *
 * OSDN REST API. Currently this API is experimental release. Pelase refer documentation on https://osdn.net/projects/osdn-codes/wiki/APIGuide and you can get client libraries from https://osdn.net/projects/osdn-codes/releases/p14859 .
 *
 * OpenAPI spec version: 0.0.20171120
 * Contact: admin@osdn.net
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace OSDN\Model;

use \ArrayAccess;

/**
 * ProjectTicketPrefs Class Doc Comment
 *
 * @category    Class */
/** 
 * @package     OSDN
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class ProjectTicketPrefs implements ArrayAccess
{
    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'ProjectTicketPrefs';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = array(
        'group_id' => 'int',
        'allow_anonymouse' => 'bool',
        'frs_autosync' => 'string',
        'mailsend_type' => 'string',
        'mailing_list_id' => 'int',
        'mail_lang' => 'string'
    );

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = array(
        'group_id' => 'group_id',
        'allow_anonymouse' => 'allow_anonymouse',
        'frs_autosync' => 'frs_autosync',
        'mailsend_type' => 'mailsend_type',
        'mailing_list_id' => 'mailing_list_id',
        'mail_lang' => 'mail_lang'
    );

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = array(
        'group_id' => 'setGroupId',
        'allow_anonymouse' => 'setAllowAnonymouse',
        'frs_autosync' => 'setFrsAutosync',
        'mailsend_type' => 'setMailsendType',
        'mailing_list_id' => 'setMailingListId',
        'mail_lang' => 'setMailLang'
    );

    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = array(
        'group_id' => 'getGroupId',
        'allow_anonymouse' => 'getAllowAnonymouse',
        'frs_autosync' => 'getFrsAutosync',
        'mailsend_type' => 'getMailsendType',
        'mailing_list_id' => 'getMailingListId',
        'mail_lang' => 'getMailLang'
    );

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = array();

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['group_id'] = isset($data['group_id']) ? $data['group_id'] : null;
        $this->container['allow_anonymouse'] = isset($data['allow_anonymouse']) ? $data['allow_anonymouse'] : null;
        $this->container['frs_autosync'] = isset($data['frs_autosync']) ? $data['frs_autosync'] : null;
        $this->container['mailsend_type'] = isset($data['mailsend_type']) ? $data['mailsend_type'] : null;
        $this->container['mailing_list_id'] = isset($data['mailing_list_id']) ? $data['mailing_list_id'] : null;
        $this->container['mail_lang'] = isset($data['mail_lang']) ? $data['mail_lang'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = array();
        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        return true;
    }


    /**
     * Gets group_id
     * @return int
     */
    public function getGroupId()
    {
        return $this->container['group_id'];
    }

    /**
     * Sets group_id
     * @param int $group_id
     * @return $this
     */
    public function setGroupId($group_id)
    {
        $this->container['group_id'] = $group_id;

        return $this;
    }

    /**
     * Gets allow_anonymouse
     * @return bool
     */
    public function getAllowAnonymouse()
    {
        return $this->container['allow_anonymouse'];
    }

    /**
     * Sets allow_anonymouse
     * @param bool $allow_anonymouse
     * @return $this
     */
    public function setAllowAnonymouse($allow_anonymouse)
    {
        $this->container['allow_anonymouse'] = $allow_anonymouse;

        return $this;
    }

    /**
     * Gets frs_autosync
     * @return string
     */
    public function getFrsAutosync()
    {
        return $this->container['frs_autosync'];
    }

    /**
     * Sets frs_autosync
     * @param string $frs_autosync
     * @return $this
     */
    public function setFrsAutosync($frs_autosync)
    {
        $this->container['frs_autosync'] = $frs_autosync;

        return $this;
    }

    /**
     * Gets mailsend_type
     * @return string
     */
    public function getMailsendType()
    {
        return $this->container['mailsend_type'];
    }

    /**
     * Sets mailsend_type
     * @param string $mailsend_type
     * @return $this
     */
    public function setMailsendType($mailsend_type)
    {
        $this->container['mailsend_type'] = $mailsend_type;

        return $this;
    }

    /**
     * Gets mailing_list_id
     * @return int
     */
    public function getMailingListId()
    {
        return $this->container['mailing_list_id'];
    }

    /**
     * Sets mailing_list_id
     * @param int $mailing_list_id
     * @return $this
     */
    public function setMailingListId($mailing_list_id)
    {
        $this->container['mailing_list_id'] = $mailing_list_id;

        return $this;
    }

    /**
     * Gets mail_lang
     * @return string
     */
    public function getMailLang()
    {
        return $this->container['mail_lang'];
    }

    /**
     * Sets mail_lang
     * @param string $mail_lang
     * @return $this
     */
    public function setMailLang($mail_lang)
    {
        $this->container['mail_lang'] = $mail_lang;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\OSDN\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\OSDN\ObjectSerializer::sanitizeForSerialization($this));
    }
}


